#!/bin/bash

{{ ansible_managed | comment }}

## Script modified by Chuev I. on 20201103 to gzip log files every two hours and move gzipped files to a new destination - /appdata/archive/outfiles
## Script modified by Kryukov E. on 20201111 for add timestamp in archive filename
## Script modified by Kryukov E. on 20210401 Replace mv /dd/ /sss (mv: Argument list too long) to find mv
## Script modified by Petrikovskii P. on 20220402 Fix old logs moving not to the day they origin
## Script modified by Petrikovskii P. on 20220426 Fix old logs moving not to the day they origin
## Script modified by Kryukov E. on 20240513 Replace gzip with find/gzip
## Script modified by Kryukov E. on 20240620 Restore archiving current day


#Check if SVFE app is running
cat /proc/mounts | grep /home/svfe

if [ $? -ne 0 ]
then
echo "SVFE is down here. Nothing to do"
exit 255
fi;

# path vars
SRC=/home/svfe/output/outfiles
DEST=/appdata/archive/outfiles

# date vars
YEAR=$(date +%Y)
MONTH=$(date +%m) # numeric month, 07
MONTH_CHAR=$(date +%b) # letter month, Jul
DAY=$(date +%d) # day with leading zero, 03
DAY_UNPADDED=$(date +%-d) # day without leading zero, 3
P_DAY=$(date --date="yesterday" +%d) # previous day with leading zero, 02
P_DAY_UNPADDED=$(date --date="yesterday" +%-d) # previous day without leading zero, 2
P_MONTH=$(date --date="yesterday" +%m) # month of the previous day numeric, 06
P_MONTH_CHAR=$(date --date="yesterday" +%b) # month of the previous day letters, Jun
P_YEAR=$(date --date="yesterday" +%Y) # year of the previous day

### GZIP files from the previous day, just in case
echo "GZIP previous day"
echo "Mask: *${P_MONTH_CHAR}${P_DAY_UNPADDED}*"
find ${SRC}/ -type f -name "*${P_MONTH_CHAR}${P_DAY_UNPADDED}*" -exec gzip -S ".$(date --date="yesterday" +%s).gz" -9 {} \;
{% if project != 'onpem' %}

    # Move previous days to OOS
    /bin/s3cmd put --recursive --preserve ${SRC}/. s3://dump_metrics/{{ project }}/{{ sub_env_name }}/svfe/output/outfiles/${P_YEAR}/${P_MONTH}/${P_DAY}/ --exclude "*" --include "*.gz" --force
{% endif %}

# Create $DEST directory for previous day
mkdir -p ${DEST}/${P_YEAR}/${P_MONTH}/${P_DAY}

# Move previous days to DEST
find ${SRC}/. -name "*.gz"  -exec mv -f {} ${DEST}/${P_YEAR}/${P_MONTH}/${P_DAY} \;

### GZIP current day files
echo "GZIP current day"
echo "Mask: *${MONTH_CHAR}${DAY_UNPADDED}*"
find ${SRC}/ -type f -name "*${MONTH_CHAR}${DAY_UNPADDED}*" -exec gzip -S ".$(date +%s).gz" -9 {} \;

# Create $DEST directory for today
mkdir -p ${DEST}/${YEAR}/${MONTH}/${DAY}

# Move to archive
find ${SRC}/. -name "*.gz"  -exec mv -f {} ${DEST}/${YEAR}/${MONTH}/${DAY} \;

# If the script skipped the schedule, the old files will remain in the directory. Gzip them
find ${SRC}/. -type f -mtime +7 -exec gzip -9 {} \;

# Remove from outdated
find ${DEST} -type f -mtime +30 -exec rm -rf {} \;
